#include "messagefacility/MessageLogger/MessageLogger.h"
#include "larcorealg/Geometry/AuxDetGeometryCore.h"
#include "larcorealg/Geometry/AuxDetGeo.h"

#include "ubcrt/CRT/CRTGeometryHelper.hh"
#include "ubcrt/CRT/CRTChannelMapAlg.hh"

#include <vector>

namespace crt
{

  CRTGeometryHelper::CRTGeometryHelper( fhicl::ParameterSet const & pset, art::ActivityRegistry & reg ) : fChannelMap(), fPset( pset ){}

  CRTGeometryHelper::~CRTGeometryHelper(){}

  void CRTGeometryHelper::doConfigureAuxDetChannelMapAlg( fhicl::ParameterSet const & sortingParameters, geo::AuxDetGeometryCore* geom )
  {
    fChannelMap.reset();
    fChannelMap = std::make_shared<CRTChannelMapAlg>( fPset, sortingParameters );
    if ( fChannelMap )
      	geom->ApplyChannelMap(fChannelMap);

  }

  CRTGeometryHelper::AuxDetChannelMapAlgPtr_t CRTGeometryHelper::doGetAuxDetChannelMapAlg() const
  {
    return fChannelMap;
  }

}

DEFINE_ART_SERVICE_INTERFACE_IMPL(crt::CRTGeometryHelper, geo::AuxDetExptGeoHelperInterface)
